#!/usr/bin/perl
# handle_cdr.pl 
# Connect to event socket, listen for CHANNEL_HANGUP_COMPLETE events 
# Uses event data to create custom CDRs 
use strict;
use warnings;
use lib '/usr/src/freeswitch.git/libs/esl/perl';
use ESL;
my $host = "localhost";
my $port = "8021";
my $pass = "ClueCon";
my $con  = new ESL::ESLconnection($host, $port, $pass);
if ( ! $con ) {
	die "Unable to establish connection to FreeSWITCH.\n";
}
## Listen for events, filter in only CHANNEL_HANGUP_COMPLETE 
$con->events('plain','all');
$con->filter('Event-Name','CHANNEL_HANGUP_COMPLETE');
print "Connected to FreeSWITCH $host:$port and waiting for 
events...\n\n";
while (1) {
	my $e = $con->recvEvent();
	my @raw_data = split "\n",$e->serialize();
	my %cdr;
	foreach my $item ( @raw_data ) {
#print "$item\n";
		my ($header, $value) = split ': ', $item;
		$header =~ s/^variable_//;
		$cdr{$header} = $value;
	}
# %cdr contains a complete list of channel variables
	print "New CDR: ";
	print $cdr{uuid} . ', ' . $cdr{direction} . ', ';
	print $cdr{answer_epoch} . ', ' . $cdr{end_epoch} . ', ';
	print $cdr{hangup_cause} . "\n";
}

