#!/usr/bin/perl
use strict;
use warnings; 
require ESL; 
use IO::Socket::INET;
my $ip = "127.0.0.1"; 
my $sock = new IO::Socket::INET ( LocalHost => $ip,
		LocalPort => '8040',
		Proto => 'tcp',
		Listen => 1,
		Reuse => 1 ); 
die "Could not create socket: $!\n" unless $sock; 
for(;;) { 
	my $new_sock = $sock->accept(); 
	my $pid = fork(); 
	if ($pid > 0) { 
		close($new_sock); 
		next; 
	} elsif ( $pid == 0 ) { 
		my $host = $new_sock->sockhost(); 
		my $fd = fileno($new_sock); 
		my $con = new ESL::ESLconnection($fd); 
		my $info = $con->getInfo(); 
		my $uuid = $info->getHeader("unique-id"); 
		my $prompt = 'file_string://voicemail/vm-to_exit.wav'; 
			$prompt .= '!voicemail/vm-press.wav!digits/9.wav'; 
		$prompt .= ' ivr/ivr-that_was_an_invalid_entry.wav'; 
		$con->execute("answer"); 
		$con->execute("playback", 
				"ivr/ivr-welcome_to_freeswitch.wav"); 
		my $digits = "1";
		while($con->connected()) { 
			while ( $digits != "9" && $con->connected() ) { 
				$con->execute("play_and_get_digits", 
						"1 1 3 5000 # $prompt mydigits \\d+"); 
				my $e = $con->api("uuid_getvar","$uuid mydigits"); 
				$digits = $e->getBody(); 
				print "Received digit $digits\n"; 
				$con->execute("sleep","1000"); 
				$con->execute("playback","ivr/ivr-you_entered.wav"); 
				$con->execute("say","en number pronounced $di-gits"); 
				$con->execute("sleep","1000"); 
				if ( $digits == "9" ) { 
					$con->execute("playback","voicemail/vm-goodbye.wav"); 
				} 
			} 
			$con->execute("hangup"); 
		} 
		close($new_sock); 
		exit(0); 
	} else { 
		die "Error forking new process: $!\n"; 
	}
} 

