#!/usr/bin/perl
use strict;
use warnings; 
use ESL::IVR; 

$| = 1;        # Turn off buffering 
select STDERR; # Use this stream for console output
print "Starting ivrd-example.pl...\n\n"; 

my $con = new ESL::IVR; 
my $uuid = $con->{_uuid}; 
my $dest = $con->getVar('destination_number'); 

$con->execute('answer'); 
$con->execute('sleep','500'); 
$con->playback('ivr/ivr-welcome_to_freeswitch.wav'); 
my $digits = "1"; 
my $prompt = 'file_string://voicemail/vm-to_exit.wav'; 
$prompt .= '!voicemail/vm-press.wav!digits/9.wav'; 
my $badinput = 'ivr/ivr-that_was_an_invalid_entry.wav'; 

while( $con->{_esl}->connected() ) { 
	while ( $con->{_esl}->connected() && $digits != "9" ) { 
		$con->playAndGetDigits(
				"1 1 3 5000 # $prompt $badinput mydigits \\d+"); 
		$digits = $con->getVar('mydigits'); 
		print "Received digit $digits\n"; 
		$con->playback("ivr/ivr-you_entered.wav"); 
		$con->execute("say","en number pronounced $digits"); 
		$con->execute("sleep","1000"); 
		if ( $digits == "9" ) { 
			$con->playback('voicemail/vm-goodbye.wav'); 
		} 
	} 
	$con->execute("hangup"); 
} 

