-- callback function, see session:setInputCallback below
function key_press(session, input_type, data, args)
	-- if we got DTMF
	if input_type == "dtmf" then
		-- print to console and logfile which key was pressed
		session:consoleLog("warning", "Key pressed: " .. data["digit"])
		-- set the "finished" variable to true
		finished = true
		-- returning "break" cause the interruption of media playing
		return "break"
	end
end

-------------------------------------------------------
-- after script finish, go back to dialplan
session:setAutoHangup(false)
-- set a function to be called on DTMFs
session:setInputCallback("key_press", "")
-- create the api object, to be used to emit fs_cli commands
api = freeswitch.API()

-- value we compare against the current price of Google stock
benchmark = 522
-- flag to break from playing and then from "while" loop
finished = false
-------------------------------------------------------

-- play a message
session:execute("playback", "ivr/ivr-when_finished_press_any_key.wav")

-- print message to console and logfile
session:consoleLog("warning", "BEFORE WHILE\n")

-- do until user hangup or variable "finished" is true
while( session:ready() == true and finished == false) do
	-- do an http query and store the result in "google_values" Lua variable
	google_values=api:execute("curl", "http://download.finance.yahoo.com/d/quotes.csv?s=GOOG&f=sl1po")
	-- print variable to console and logfile
	session:consoleLog("warning", "google_values is: " .. google_values .. "\n")
	-- parse variable into components
	_,_,var1,var2,var3,var4 = string.find(google_values,"(.-),(.-),(.-),(.*)")
	-- print components to console and logfile
	session:consoleLog("warning", "var1="..var1.." var2="..var2.." var3="..var3.." var4="..var4.."\n")
	-- "pronounce" component to user
	session:say(var2, "en", "currency", "pronounced")
	-- check if exit time
	if(finished==true)then break end

	-- evaluate if component is less than benchmark
	if(tonumber(var2) < benchmark) then
		-- if component is less than benchmark
		-- play a message
		session:execute("playback", "ivr/ivr-less_than.wav")
		-- check if exit time
		if(finished==true)then break end
	else
		-- if component is equal or more than benchmark
		-- play a message
		session:execute("playback", "ivr/ivr-more_than.wav")
		-- check if exit time
		if(finished==true)then break end
	end

	-- "pronounce" benchmark to user
	session:say(benchmark, "en", "currency", "pronounced")
	-- check if exit time
	if(finished==true)then break end
	-- pause half a second
	session:sleep(500)
end

-- print message to console and logfile
session:consoleLog("warning", "AFTER WHILE\n")

-- pause half seconds
session:sleep(500)

--End of script, we set autohangup to false, will go back to dialplan

